<?php

// Add an event handler for a prefilter
add_event_handler('loc_begin_picture', 'copyrights_set_prefilter_add_to_pic_info', 55 );

// Change the variables used by the function that changes the template
add_event_handler('loc_begin_picture', 'copyrights_add_image_vars_to_template');

// Add the prefilter to the template
function copyrights_set_prefilter_add_to_pic_info()
{
	global $template;
	$template->set_prefilter('picture', 'copyrights_add_to_pic_info');
}

// Insert the template for the copyright display
function copyrights_add_to_pic_info($content, &$smarty)
{
	// Add the information after the author - so before the createdate
	$search = '#<tr id="datecreate">#';
	
	$replacement = '
	<tr id="Copyrights_name">
		<td class="label">{\'Copyright\'|@translate}</td>
		<td class="value">
			{if $CR_INFO_NAME}
			<a target="_blanc" href="{$CR_INFO_URL}" title="{$CR_INFO_NAME}: {$CR_INFO_DESCR}">{$CR_INFO_NAME}</a>
			{else}{\'N/A\'|@translate}{/if}
		</td>
	</tr>
	<tr id="datecreate">';

	return preg_replace($search, $replacement, $content);
}

// Assign values to the variables in the template
function copyrights_add_image_vars_to_template()
{
	global $page, $template, $prefixeTable;

	// Show block only on the photo page
	if ( !empty($page['image_id']) )
	{
		// Get the copyright name, url and description that belongs to the current media_item
		$query = sprintf('
		  select name, url, descr
		  FROM %s NATURAL JOIN %s
		  WHERE media_id = %s
		  AND visible = 1
      ;',
      COPYRIGHTS_ADMIN, COPYRIGHTS_MEDIA, $page['image_id']);
		$result = pwg_query($query);
		$row = pwg_db_fetch_row($result);
		$name = '';
		$url = '';
		$descr = '';
		if(count($row) > 0) {
			$name = $row[0];
			$url = $row[1];
			$descr = $row[2];
		}
			
		// Sending data to the template
    $template->assign(
      array	(
        'CR_INFO_NAME' => $name,
        'CR_INFO_URL' => $url,
        'CR_INFO_DESCR' => $descr
      )
    );
	}
}

?>
